[LeetCode] Lowest Common Ancestor of a Binary Search Tree

时间:2022-08-26 10:05:29

Given a binary search tree (BST), find the lowest common ancestor (LCA) of two given nodes in the BST.

According to the definition of LCA on Wikipedia: “The lowest common ancestor is defined between two nodes v and w as the lowest node in T that has both v and w as descendants (where we allow a node to be a descendant of itself).”

        _______6______
       /              \
    ___2__          ___8__
   /      \        /      \
   0      _4       7       9
         /  \
         3   5

For example, the lowest common ancestor (LCA) of nodes 2 and 8 is 6. Another example is LCA of nodes 2 and 4 is 2, since a node can be a descendant of itself according to the LCA definition.

     这道题不难。主要是先要搞清楚LCA的定义。

     然后LCA呢只会分为三种情况,如果P,Q中最大值的那个都小于root的值,那么LCA只能在左边了。反正如果P,Q中最小值的那个都大于root的值,那么LCA肯定只能在右边。如果这两种情况都不是,那么就是最特殊的一种。LCA直接就是root。因为没有办法把这两个node一起放在一边子树去了。

     代码如下。~

/**
 * Definition for a binary tree node.
 * public class TreeNode {
 *     int val;
 *     TreeNode left;
 *     TreeNode right;
 *     TreeNode(int x) { val = x; }
 * }
 */
public class Solution {
    public TreeNode lowestCommonAncestor(TreeNode root, TreeNode p, TreeNode q) {
        if(root==null){
            return null;
        }
        if(Math.max(p.val,q.val)<root.val){
           return lowestCommonAncestor(root.left,p,q);
        }else if(Math.min(p.val,q.val)>root.val){
            return lowestCommonAncestor(root.right,p,q);
        }
        return root;
    }
}